<?php

/** met à jour le unattend.xml ou le sysprep.xml pour fixer les mots de passe, nom du poste pour la mise au domaine
 * @param unknown $config
 * @param unknown $file
 * @param unknown $hostname
 * @return string xml
 */
function update_xml_unattend($config, $file, $attrs, $specialize = false, $os = "10")
{
    $xml = new DOMDocument();
    $xml->formatOutput = true;
    $xml->preserveWhiteSpace = false;
    $xml->load($file);
    $passwords = $xml->documentElement->getElementsByTagName('Value');
    $domainpasswords = $xml->documentElement->getElementsByTagName('Password');
    $usernames = $xml->documentElement->getElementsByTagName('Username');
    $names = $xml->documentElement->getElementsByTagName('Name');
    $displaynames = $xml->documentElement->getElementsByTagName('DisplayName');
    $fullnames = $xml->documentElement->getElementsByTagName('FullName');
    $registeredowners = $xml->documentElement->getElementsByTagName('RegisteredOwner');
    $commandlines = $xml->documentElement->getElementsByTagName('CommandLine');
    $computernames = $xml->documentElement->getElementsByTagName('ComputerName');
    $ous = $xml->documentElement->getElementsByTagName('MachineObjectOU');
    $domains = $xml->documentElement->getElementsByTagName('Domain');
    $joindomains = $xml->documentElement->getElementsByTagName('JoinDomain');
    $settings = $xml->getElementsByTagName('settings');

    if ($specialize) {
        foreach ($settings as $setting) {
            if ($setting->getAttribute('pass') == "generalize") {
                $setting->setAttribute('wasPassProcessed', "true");
            }
        }
    }
    // autologon admin
    if (isset($usernames[1]))
        $usernames[1]->nodeValue = "admin@" . $config['domain'];
    $passwords[0]->nodeValue = $config['ldap_admin_passwd'];
    // Administrator local
    $passwords[2]->nodeValue = $config['adminse_passwd'];

    // mise au domaine Administrator sambaedu
    $usernames[0]->nodeValue = $config['ldap_admin_name'];
    $domainpasswords[0]->nodeValue = $config['ldap_admin_passwd'];
    // Adminse local
    foreach ($names as $name) {
        $name->nodeValue = $config['adminse_name'];
    }
    $passwords[1]->nodeValue = $config['adminse_passwd'];
    foreach ($displaynames as $name) {
        $name->nodeValue = $config['adminse_name'];
    }
    foreach ($fullnames as $name) {
        $name->nodeValue = $config['adminse_name'];
    }
    foreach ($registeredowners as $name) {
        $name->nodeValue = $config['adminse_name'];
    }
    foreach ($commandlines as $name) {
        $name->nodeValue = preg_replace("/###_ADMINSE_NAME_###/", $config['adminse_name'], $name->nodeValue);
        $name->nodeValue = preg_replace("/###_SE4FS_NAME_###/", $config['se4fs_name'], $name->nodeValue);
    }
    foreach ($computernames as $name) {
        $name->nodeValue = $attrs['name'] ?? "*";
    }
    foreach ($ous as $name) {
        $name->nodeValue = $attrs['ou'] ?? $config['dn']['computers'];
    }
    foreach ($domains as $name) {
        $name->nodeValue = $config['domain'];
    }
    foreach ($joindomains as $name) {
        $name->nodeValue = $config['domain'];
    }
    if ($os == "7"){
        $node = $xml->documentElement->getElementsByTagName('HideOEMRegistrationScreen')->item(0);
        $node->parentNode->removeChild($node);
        $node = $xml->documentElement->getElementsByTagName('HideOnlineAccountScreens')->item(0);
        $node->parentNode->removeChild($node);    
    }
    return $xml->saveXML();
}
?>